=== modified file 'src/dialogs/export.cpp'
--- src/dialogs/export.cpp	2010-04-10 19:44:27 +0000
+++ src/dialogs/export.cpp	2010-08-28 21:19:08 +0000
@@ -355,26 +355,22 @@
 
     gchar * directory = NULL;
 
-    if (directory == NULL && file_entry_text != NULL && file_entry_text[0] != '\0') {
-        // std::cout << "Directory from dialog" << std::endl;
+    if (file_entry_text != NULL && file_entry_text[0] != '\0') {        
         directory = g_dirname(file_entry_text);
-    }
-
-    if (directory == NULL) {
-        /* Grab document directory */
-        if (SP_DOCUMENT_URI(SP_ACTIVE_DOCUMENT)) {
-            // std::cout << "Directory from document" << std::endl;
-            directory = g_dirname(SP_DOCUMENT_URI(SP_ACTIVE_DOCUMENT));
+        if (!strcmp(directory, ".")){
+            directory = NULL;
         }
     }
 
-    if (directory == NULL) {
-        // std::cout << "Home Directory" << std::endl;
-        directory = homedir_path(NULL);
+    gchar *id_ext = g_strconcat(id, ".png", NULL);
+    gchar *filename = NULL;
+    
+    if (directory != NULL) {
+        filename = g_build_filename(directory, id_ext, NULL);
+    } else {
+        filename = g_strdup(id_ext);
     }
-
-    gchar * id_ext = g_strconcat(id, ".png", NULL);
-    gchar *filename = g_build_filename(directory, id_ext, NULL);
+    
     g_free(directory);
     g_free(id_ext);
     return filename;
@@ -524,8 +520,9 @@
             Gtk::Entry *fe = new Gtk::Entry();
 
             /*
-             * set the default filename to be that of the current path + document
-             * with .png extension
+             * set the default filename to be that of the current document
+             * with .png extension (ignoring the path, since relative paths
+             * mean we now don't need to worry about that)
              *
              * One thing to notice here is that this filename may get
              * overwritten, but it won't happen here.  The filename gets
@@ -539,7 +536,7 @@
             {
                 gchar *name;
                 SPDocument * doc = SP_ACTIVE_DOCUMENT;
-                const gchar *uri = SP_DOCUMENT_URI (doc);
+                const gchar *docname = SP_DOCUMENT_NAME (doc);
                 const gchar *text_extension = get_file_save_extension (Inkscape::Extension::FILE_SAVE_METHOD_SAVE_AS).c_str();
                 Inkscape::Extension::Output * oextension = NULL;
 
@@ -549,12 +546,12 @@
 
                 if (oextension != NULL) {
                     gchar * old_extension = oextension->get_extension();
-                    if (g_str_has_suffix(uri, old_extension)) {
+                    if (g_str_has_suffix(docname, old_extension)) {
                         gchar * uri_copy;
                         gchar * extension_point;
                         gchar * final_name;
 
-                        uri_copy = g_strdup(uri);
+                        uri_copy = g_strdup(docname);
                         extension_point = g_strrstr(uri_copy, old_extension);
                         extension_point[0] = '\0';
 
@@ -565,7 +562,7 @@
                         g_free(uri_copy);
                     }
                 } else {
-                    name = g_strconcat(uri, ".png", NULL);
+                    name = g_strconcat(docname, ".png", NULL);
                     fe->set_text(name);
                     g_free(name);
                 }

